@echo off
if "%1"=="" goto usage

set ASM83DIR=%cd%\
cd %2
call %ASM83DIR%_getall.bat

echo ----- Assembling %3 for TI-83 Venus...
echo #define TI83 >_temp_.z80
echo #define VENUS >>_temp_.z80
if exist %1.z80 type %1.z80 >>_temp_.z80
if exist %1.asm type %1.asm >>_temp_.z80
%ASM83DIR%tasm -80 -i -b -l _temp_.z80 %3.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%devpac83 %3
copy %3.83p %3v.83p > nul
copy %3.83p %ASM83DIR%%3v.83p > nul
del %3.83p > nul

echo ----- Assembling %3 for TI-83 ION...
echo #define TI83 >_temp_.z80
echo #define ION >>_temp_.z80
if exist %1.z80 type %1.z80 >>_temp_.z80
if exist %1.asm type %1.asm >>_temp_.z80
%ASM83DIR%tasm -80 -i -b -l _temp_.z80 %3.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%devpac83 %3
copy %3.83p %ASM83DIR% > nul

echo ----- Assembling %3 for TI-83+ ION...
echo #define TI83P >_temp_.z80
echo #define ION >>_temp_.z80
if exist %1.z80 type %1.z80 >>_temp_.z80
if exist %1.asm type %1.asm >>_temp_.z80
%ASM83DIR%tasm -80 -i -b -l _temp_.z80 %3.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%devpac8x %3
copy %3.8xp %ASM83DIR% > nul

echo ----- Assembling %3 for TI-82 ACE...
echo #define TI82 >_temp_.z80
echo #define ACE >>_temp_.z80
if exist %1.z80 type %1.z80 >>_temp_.z80
if exist %1.asm type %1.asm >>_temp_.z80
%ASM83DIR%tasm -80 -i -b -l _temp_.z80 %3.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%ace82 %3.bin
copy %3.82p %3a.82p > nul
copy %3.82p %ASM83DIR%%3a.82p > nul

echo ----- Assembling %3 for TI-82 CrASH 19006...
echo #define TI82 >_temp_.z80
echo #define CRASH19006 >>_temp_.z80
if exist %1.z80 type %1.z80 >>_temp_.z80
if exist %1.asm type %1.asm >>_temp_.z80
%ASM83DIR%tasm -80 -i -b -l _temp_.z80 %3.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%CRPRGM82 %3.bin
copy %3.82p %3_19006.82p > nul
copy %3.82p %ASM83DIR%%3_19006.82p > nul

echo ----- Assembling %3 for TI-82 CrASH...
echo #define TI82 >_temp_.z80
echo #define CRASH >>_temp_.z80
if exist %1.z80 type %1.z80 >>_temp_.z80
if exist %1.asm type %1.asm >>_temp_.z80
%ASM83DIR%tasm -80 -i -b -l _temp_.z80 %3.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%CRPRGM82 %3.bin
copy %3.82p %ASM83DIR%%3.82p > nul

echo ----- Success!
echo TI-83 VENUS version is %3v.83p
echo TI-83 ION version is %3.83p
echo TI-83+ ION version is %3.8xp
echo TI-82 ACE version is %3a.82p
echo TI-82 CrASH version is %3.82p
echo TI-82 CrASH 19006 version is %3_19006.82p


goto DONE
:ERRORS
echo ----- There were errors.
:DONE
del _temp_.z80 > nul
del %3.bin > nul

call %ASM83DIR%_cleanall.bat
cd %ASM83DIR%
set ASM83DIR=

goto Done2
:usage
echo Usage:
echo -----------------------------------------------------------------------------
echo   %0 progname [progpath]
echo.
echo   Progname is the base filename of the program, leave off the file extension.
echo   Progpath is a path to the program, so you can compile a project located in
echo   in a different folder.  Run this .bat file from the TASM folder.
echo.
echo   This .bat builds TI82 Crash and ACE programs, TI83 ION and Venus programs,
echo   and TI83+ ION programs.
echo.
:Done2